; 24 užduotis: 
; Parašykite programą, kuri įvestoje eilutėje visus tarpo simbolius pakeičia 
; po jais sekančiais simboliais (jei tarpas gale - paliekamas tarpas).
; Pvz.: įvedus "ab 12 oi8" turi atspausdinti "abb122oi8"

EIL_PAB equ '$'
TARPAS equ ' '
IVEDIMAS equ 0ah
ISVEDIMAS equ 9h

SSeg segment stack
	db 100h dup (?)
SSeg ends

DSeg segment
	EilBuf db 252, 254 dup (?)
DSeg ends

CSeg segment
	assume cs:CSeg, ds:DSeg, ss:SSeg
	
	; pagrindinė procedūra
	START proc far
		; Inicializuojam programos
		; įėjimo adresą
		push ds
		sub	ax, ax
		push ax
		mov ax, DSeg
		mov ds, ax

		; Programos kodas
		
		; iš klaviatūros nuskaitoma eilutė
		lea dx, EilBuf
		mov ah, IVEDIMAS
		int 21h
		
		; į ax patalpinamas eilutės ilgis
		xor ax, ax
		mov si, offset EilBuf
		inc si
		add al, [si]
		
		; jei eilutė tuščia, programa pabaigiama
		cmp ax, 0
		je BAIGTI		
		
		; nagrinėjama eilutė
	NAGR_SIMB:
		inc si
		dec ax
		cmp ax, 0
		je TESTI		; jei paskutinis simbolis - išeinama iš ciklo
		cmp byte ptr [si], TARPAS
		je KEISTI_SIMB	; jei randamas tarpas, simbolis pakeičiamas
		jmp NAGR_SIMB	; grįžtama į ciklo pradžią
		
		; tarpas pakeičiamas tolesniu simboliu
	KEISTI_SIMB:
		mov bl, byte ptr [si+1]
		mov [si], bl
		jmp NAGR_SIMB	; grįžtama į ciklo pradžią
		
	TESTI:
		; buferio gale pridedamas simbolis '$'
		; si rodo į paskutinį eilutės simbolį
		inc si
		mov cl, EIL_PAB
		mov [si], cl
		
		; eilutė išvedama į ekraną
		lea dx, EilBuf
		add dx, 2		; eilutė buferyje prasideda nuo trečio baito
		mov ah, ISVEDIMAS
		int 21h

		; Grįžti į DOS
	BAIGTI:
		ret
	START endp
	
CSeg ends

end Start

